# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Protected Member Functions | Private Attributes | List of all members
dirac::ParseUnitByteIO Class Reference

Represents a collection of data in a Dirac bytestream that can be parsed as a self-contained unit.

`#include <parseunit_byteio.h>`

Inheritance diagram for dirac::ParseUnitByteIO:
[legend]
Collaboration diagram for dirac::ParseUnitByteIO:
[legend]

## Public Member Functions
| ParseUnitByteIO ()
| Constructor. More...
| ParseUnitByteIO (const ByteIO &byte_io)
| Constructor. More...
| ParseUnitByteIO (const ParseUnitByteIO &parseunit_byteio)
| Constructor. More...
| ~ParseUnitByteIO ()
| Destructor. More...
virtual void | CollateByteStats (DiracByteStats &dirac_byte_stats)
| Gathers byte stats on the parse-unit data. More...
bool | Input ()
| Reads from byte-stream to find parse data. More...
bool | IsValid ()
| Accesses validity of a unit by comparing it with an adjacent unit. More...
bool | CanSkip ()
| Can Skip past the entire parse-unit. More...
virtual const std::string | GetBytes ()
| Gets string containing coded bytes. More...
void | SetAdjacentParseUnits (ParseUnitByteIO *p_prev_parseunit)
| Set next/previous parse-unit values. More...
virtual int | GetSize () const
| Gets size (in bytes) More...
int | GetNextParseOffset () const
| Gets expected number of bytes to start of next parse-unit. More...
int | GetPreviousParseOffset () const
| Gets number of bytes to start of previous parse-unit. More...
virtual ParseUnitType | GetType () const
| Gets parse-unit type. More...
bool | IsSeqHeader () const
| Returns true is parse unit is a Sequence Header. More...
bool | IsEndOfSequence () const
| Returns true is parse unit is an End of Sequence unit. More...
bool | IsAuxiliaryData () const
| Returns true is parse unit is Auxiliary Data. More...
bool | IsPaddingData () const
| Returns true is parse unit is Padding data. More...
bool | IsPicture () const
| Returns true is parse unit is Picture data. More...
bool | IsLowDelay () const
| Returns true is parse unit is Low Delay Sybtax unit. More...
bool | IsCoreSyntax () const
| Returns true is parse unit is Core syntax unit. More...
bool | IsUsingAC () const
| Returns true is parse unit uses Arithmetic coding. More...
Public Member Functions inherited from dirac::ByteIO
| ByteIO (bool new_stream=true)
| Default constructor. More...
| ByteIO (const ByteIO &stream_data)
| Constructor. More...
virtual | ~ByteIO ()
| Destructor. More...
virtual void | CollateByteStats (DiracByteStats &dirac_byte_stats)
| Gathers byte-stream statistics. More...
virtual const std::string | GetBytes ()
| Get bytes in Dirac-bytestream format. More...
int | GetReadBytePosition () const
| Get position of read stream pointer. More...
virtual int | GetSize () const
| Gets size (in bytes) More...
void | SetByteParams (const ByteIO &byte_io)
| Copies stream source/destination info. More...
void | ByteAlignOutput ()
| Sync input for byte-alignment. More...
void | WriteUint (unsigned int value)
| Ouputs an unsigned integer in interleaved exp Golomb format. More...
void | SetBitsLeft (int left_bits)
| Sets input size in bits. More...
int | BitsLeft (void)
| Sets input size in bits. More...

## Protected Member Functions
virtual int | CalcNextUnitOffset ()
| Calculates number of bytes to start of next unit. More...
virtual unsigned char | CalcParseCode () const
| Pure virtual method for calculating parse-code. More...
bool | SyncToUnitStart ()
| Locates start of parse-unit. More...
unsigned char | GetParseCode () const
| Get parse code. More...
Protected Member Functions inherited from dirac::ByteIO
bool | CanRead () const
bool | GetBit (unsigned char &c, int pos) const
void | SetBit (unsigned char &c, int pos) const
void | SetBits (unsigned char &c, unsigned char bits) const
void | ByteAlignInput ()
| Sync input for byte-alignment. More...
bool | ReadBool ()
| Reads boolean value. More...
bool | ReadBoolB ()
| Reads boolean value - bounded i/o. More...
int | ReadBit ()
| Reads next bit. More...
int | ReadBitB ()
| Reads next bit - bounded i/o. More...
unsigned int | ReadNBits (int count)
| Reads next 'count' bits. More...
void | InputBytes (char *data, int count)
| Reads from stream. More...
void | FlushInputB ()
| Flushes the bounde input. More...
int | ReadSint ()
| Reads a signed integer in interleaved exp-Golomb format return Signed integer read. More...
int | ReadSintB ()
| Reads a signed integer in interleaved exp-Golomb format from bounded input return Signed integer read. More...
unsigned int | ReadUint ()
| Reads an unsigned integer in interleaved exp Golomb format. More...
unsigned int | ReadUintB ()
| Reads an unsigned integer in interleaved exp Golomb format from bounded input. More...
unsigned int | ReadUintLit (const int byte_size)
| Reads a fixed length unsigned integer from the stream in big endian. More...
unsigned char | InputUnByte ()
| Reads a byte from the stream. More...
std::string | InputUnString (const int count)
| Reads a series of bytes from a stream. More...
void | WriteBit (const bool &bit)
| Outputs a bit. More...
int | WriteNBits (unsigned int val)
| Outputs an unsigned integer. More...
void | WriteNBits (unsigned int val, int count)
| Outputs an n bit integer. More...
void | OutputBytes (const std::string &bytes)
| Outputs a series of bytes. More...
void | OutputCurrentByte ()
| Outputs current byte contents. More...
void | WriteSint (int val)
| Outputs an integer in Golomb signed integer format. More...
void | WriteUintLit (const unsigned int &value, const int &length)
| Output unsigned int value in big endian format. More...
void | RemoveRedundantBytes (const int count)
| Removes portion of byte-stream no longer required. More...
void | SeekGet (const int offset, std::ios_base::seekdir dir)

## Private Attributes
int | m_previous_parse_offset
| Number of bytes to next parse-unit. More...
int | m_next_parse_offset
| Number of bytes to previous parse-unit. More...
unsigned char | m_parse_code
| Parse-type-identifier. More...

## Additional Inherited Members
Protected Attributes inherited from dirac::ByteIO
std::stringstream * | mp_stream
| Input/output steam. More...

## Constructor & Destructor Documentation

## ◆ ParseUnitByteIO() [1/3]

dirac::ParseUnitByteIO::ParseUnitByteIO | ( |  | ) |

## ◆ ParseUnitByteIO() [2/3]

dirac::ParseUnitByteIO::ParseUnitByteIO | ( | const ByteIO & | byte_io | ) |

Parameters

  byte_io | Stream parameters

## ◆ ParseUnitByteIO() [3/3]

dirac::ParseUnitByteIO::ParseUnitByteIO | ( | const ParseUnitByteIO & | parseunit_byteio | ) |

Parameters

  parseunit_byteio | Parse-unit parameters

## ◆ ~ParseUnitByteIO()

dirac::ParseUnitByteIO::~ParseUnitByteIO | ( |  | ) |

## Member Function Documentation

## ◆ CalcNextUnitOffset()

virtual int dirac::ParseUnitByteIO::CalcNextUnitOffset | ( |  | ) |
| protected virtual

Returns
  Number of bytes to next unit

Reimplemented in dirac::EndOfSequenceByteIO.

## ◆ CalcParseCode()

virtual unsigned char dirac::ParseUnitByteIO::CalcParseCode | ( |  | ) | const
| inline protected virtual

Returns
  Char containing bit-set for parse-unit parameters

Reimplemented in dirac::SequenceHeaderByteIO, dirac::EndOfSequenceByteIO, and dirac::PictureByteIO.

## ◆ CanSkip()

bool dirac::ParseUnitByteIO::CanSkip | ( |  | ) |

Returns
  false Nothing to skip to

## ◆ CollateByteStats()

virtual void dirac::ParseUnitByteIO::CollateByteStats | ( | DiracByteStats & | dirac_byte_stats | ) |
| virtual

Parameters

  dirac_byte_stats | Stat container

Reimplemented from dirac::ByteIO.

Reimplemented in dirac::EndOfSequenceByteIO, and dirac::PictureByteIO.

## ◆ GetBytes()

virtual const std::string dirac::ParseUnitByteIO::GetBytes | ( |  | ) |
| virtual

Reimplemented from dirac::ByteIO.

Reimplemented in dirac::PictureByteIO.

## ◆ GetNextParseOffset()

int dirac::ParseUnitByteIO::GetNextParseOffset | ( |  | ) | const

## ◆ GetParseCode()

unsigned char dirac::ParseUnitByteIO::GetParseCode | ( |  | ) | const
| inline protected

References m_parse_code.

Referenced by dirac::PictureByteIO::IsNonRef(), dirac::PictureByteIO::IsRef(), and dirac::PictureByteIO::NumRefs().

## ◆ GetPreviousParseOffset()

int dirac::ParseUnitByteIO::GetPreviousParseOffset | ( |  | ) | const

## ◆ GetSize()

virtual int dirac::ParseUnitByteIO::GetSize | ( |  | ) | const
| virtual

Reimplemented from dirac::ByteIO.

Reimplemented in dirac::SequenceHeaderByteIO, and dirac::PictureByteIO.

## ◆ GetType()

virtual ParseUnitType dirac::ParseUnitByteIO::GetType | ( |  | ) | const
| virtual

Reimplemented in dirac::SequenceHeaderByteIO, dirac::EndOfSequenceByteIO, and dirac::PictureByteIO.

## ◆ Input()

bool dirac::ParseUnitByteIO::Input | ( |  | ) |

Returns
  false if not enough data in stream

## ◆ IsAuxiliaryData()

bool dirac::ParseUnitByteIO::IsAuxiliaryData | ( |  | ) | const
| inline

References m_parse_code.

## ◆ IsCoreSyntax()

bool dirac::ParseUnitByteIO::IsCoreSyntax | ( |  | ) | const
| inline

References m_parse_code.

## ◆ IsEndOfSequence()

bool dirac::ParseUnitByteIO::IsEndOfSequence | ( |  | ) | const
| inline

References m_parse_code.

## ◆ IsLowDelay()

bool dirac::ParseUnitByteIO::IsLowDelay | ( |  | ) | const
| inline

References m_parse_code.

## ◆ IsPaddingData()

bool dirac::ParseUnitByteIO::IsPaddingData | ( |  | ) | const
| inline

References m_parse_code.

## ◆ IsPicture()

bool dirac::ParseUnitByteIO::IsPicture | ( |  | ) | const
| inline

References m_parse_code.

Referenced by dirac::PictureByteIO::IsInter(), and dirac::PictureByteIO::IsIntra().

## ◆ IsSeqHeader()

bool dirac::ParseUnitByteIO::IsSeqHeader | ( |  | ) | const
| inline

References m_parse_code.

## ◆ IsUsingAC()

bool dirac::ParseUnitByteIO::IsUsingAC | ( |  | ) | const
| inline

References m_parse_code.

## ◆ IsValid()

bool dirac::ParseUnitByteIO::IsValid | ( |  | ) |

## ◆ SetAdjacentParseUnits()

void dirac::ParseUnitByteIO::SetAdjacentParseUnits | ( | ParseUnitByteIO * | p_prev_parseunit | ) |

Parameters

  p_prev_parseunit | Previous parse-unit

## ◆ SyncToUnitStart()

bool dirac::ParseUnitByteIO::SyncToUnitStart | ( |  | ) |
| protected

Returns
  false if not enough data

## Member Data Documentation

## ◆ m_next_parse_offset

int dirac::ParseUnitByteIO::m_next_parse_offset
| private

## ◆ m_parse_code

unsigned char dirac::ParseUnitByteIO::m_parse_code
| private

Referenced by GetParseCode(), IsAuxiliaryData(), IsCoreSyntax(), IsEndOfSequence(), IsLowDelay(), IsPaddingData(), IsPicture(), IsSeqHeader(), and IsUsingAC().

## ◆ m_previous_parse_offset

int dirac::ParseUnitByteIO::m_previous_parse_offset
| private

The documentation for this class was generated from the following file:

- parseunit_byteio.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.